/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.BandejaEntradasDao;
import com.ejie.ad74a.model.BandejaEntradas;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * BandejaEntradasServiceImpl generated by UDA, 06-jun-2023 9:23:12.
 * 
 * @author UDA
 */

@Service(value = "bandejaEntradasService")
public class BandejaEntradasServiceImpl implements BandejaEntradasService {

	@Autowired
	private BandejaEntradasDao bandejaEntradasDao;

	/**
	 * Finds a single row in the BandejaEntradas table.
	 *
	 * @param bandejaEntradas BandejaEntradas
	 *
	 * @return BandejaEntradas
	 */
	public BandejaEntradas find(BandejaEntradas bandejaEntradas) {
		return (BandejaEntradas) this.bandejaEntradasDao.find(bandejaEntradas);
	}

	/**
	 * Finds a list of rows in the BandejaEntradas table.
	 *
	 * @param bandejaEntradas BandejaEntradas
	 * @param tableRequestDto TableRequestDto
	 *
	 * @return List<BandejaEntradas>
	 */
	public List<BandejaEntradas> findAll(BandejaEntradas bandejaEntradas, TableRequestDto tableRequestDto) {
		return (List<BandejaEntradas>) this.bandejaEntradasDao.findAll(bandejaEntradas, tableRequestDto);
	}

	/**
	 * Finds rows in the BandejaEntradas table using like.
	 *
	 * @param bandejaEntradas BandejaEntradas
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * 
	 * @return List<BandejaEntradas>
	 */
	public List<BandejaEntradas> findAllLike(BandejaEntradas bandejaEntradas, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<BandejaEntradas>) this.bandejaEntradasDao.findAllLike(bandejaEntradas, tableRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter method in the BandejaEntradas table.
	 *
	 * @param filterBandejaEntradas BandejaEntradas
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return TableResourceResponseDto<BandejaEntradas>
	 */
	public TableResponseDto<BandejaEntradas> filter(BandejaEntradas filterBandejaEntradas,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<BandejaEntradas> listaBandejaEntradas = this.bandejaEntradasDao.findAllLike(filterBandejaEntradas,
				tableRequestDto, false);

		Long recordNum = this.bandejaEntradasDao
				.findAllLikeCount(filterBandejaEntradas != null ? filterBandejaEntradas : new BandejaEntradas(), false);
		TableResponseDto<BandejaEntradas> tableResponseDto = new TableResponseDto<BandejaEntradas>(tableRequestDto,
				recordNum, listaBandejaEntradas);

//		if (tableRequestDto.getMultiselection().getSelectedIds() != null
//				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
//			List<TableRowDto<BandejaEntradas>> reorderSelection = this.bandejaEntradasDao
//					.reorderSelection(filterBandejaEntradas, tableRequestDto, startsWith);
//			tableResponseDto.setReorderedSelection(reorderSelection);
//			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
//			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
//		}
//		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
//			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
//			List<TableRowDto<BandejaEntradas>> reorderSeeker = this.bandejaEntradasDao
//					.reorderSelection(filterBandejaEntradas, tableRequestDto, startsWith);
//			tableResponseDto.setReorderedSeeker(reorderSeeker);
//			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
//		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the BandejaEntradas table.
	 *
	 * @param filterBandejaEntradas BandejaEntradas
	 * @param searchBandejaEntradas BandejaEntradas
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return List<TableRowDto<BandejaEntradas>>
	 */
	public List<TableRowDto<BandejaEntradas>> search(BandejaEntradas filterBandejaEntradas,
			BandejaEntradas searchBandejaEntradas, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.bandejaEntradasDao.search(filterBandejaEntradas, searchBandejaEntradas, tableRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in BandejaEntradas table.
	 *
	 * @param filterBandejaEntradas BandejaEntradas
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return Object
	 */
	public Object reorderSelection(BandejaEntradas filterBandejaEntradas, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.bandejaEntradasDao.reorderSelection(filterBandejaEntradas, tableRequestDto, startsWith);
	}

	@Transactional(rollbackFor = Throwable.class)
	public List<BandejaEntradas> getMultiple(BandejaEntradas filterBandejaEntradas, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.bandejaEntradasDao.getMultiple(filterBandejaEntradas, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterBandejaEntradas BandejaEntradas
	 * @param columns               String[]
	 * @param columnsName           String[]
	 * @param fileName              String
	 * @param sheetTitle            String
	 * @param reportsParams         ArrayList<?>
	 * @param tableRequestDto       TableRequestDto
	 * @param request               HttpServletRequest
	 * @param response              HttpServletResponse
	 */
	@Override
	public void generateReport(BandejaEntradas filterBandejaEntradas, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, ArrayList<?> reportsParams, TableRequestDto tableRequestDto,
			HttpServletRequest request, HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<BandejaEntradas> filteredData = getDataForReports(filterBandejaEntradas, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : BandejaEntradas.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = BandejaEntradas.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					BandejaEntradas.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// Si no se definen los nombres de las columnas se dejan las definidas por
		// defecto
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaEntradas>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<BandejaEntradas> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(columnsName[i]);
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (BandejaEntradas rowBandejaEntradas : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellBandejaEntradas = row.createCell(cellNumber++);
					cellBandejaEntradas.setCellValue(getCellValue(column, rowBandejaEntradas));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaEntradas>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<BandejaEntradas> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (BandejaEntradas rowBandejaEntradas : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowBandejaEntradas));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaEntradas>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<BandejaEntradas> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (BandejaEntradas rowBandejaEntradas : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowBandejaEntradas));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<BandejaEntradas>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<BandejaEntradas> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (BandejaEntradas rowBandejaEntradas : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowBandejaEntradas);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterBandejaEntradas BandejaEntradas
	 * @param tableRequestDto       TableRequestDto
	 *
	 * @return List<BandejaEntradas>
	 */
	public List<BandejaEntradas> getDataForReports(BandejaEntradas filterBandejaEntradas,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterBandejaEntradas != null) {
				return this.bandejaEntradasDao.findAllLike(filterBandejaEntradas, tableRequestDto, false);
			} else {
				return this.bandejaEntradasDao.findAll(new BandejaEntradas(), null);
			}
		} else {
			return this.bandejaEntradasDao.getMultiple(filterBandejaEntradas, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column             String
	 * @param rowBandejaEntradas BandejaEntradas
	 *
	 * @return String
	 */
	private String getCellValue(String column, BandejaEntradas rowBandejaEntradas) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowBandejaEntradas, column) != null
					? BeanUtils.getProperty(rowBandejaEntradas, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	@Override
	public List<BandejaEntradas> getEntradasExpediente(Long codExpediente, String pendiente) {
		return this.bandejaEntradasDao.getEntradasExpediente(codExpediente, pendiente);
	}
}
